SystemOrganization addCategory: #FuelPackageLoaderMetacello!

!MetacelloGoferLoad methodsFor: '*FuelPackageLoaderMetacello' stamp: 'MarianoMartinezPeck 5/2/2012 19:36'!
execute

	super execute.
	FLMetacelloStore default packagesHasBeenLoaded: (self model versions collect: [:version | version package name]).! !

Object subclass: #FLMetacelloStore
	instanceVariableNames: 'prefix capturing capturedPackageNames allPackagesTogetherStream'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'FuelPackageLoaderMetacello'!

!FLMetacelloStore commentStamp: 'MartinDias 9/29/2011 04:16' prior: 0!
I capture and export in Fuel files a Metacello load.

Example: loading Seaside 3

1) Install Fuel in a CLEAN Pharo 1.3 image:
Gofer it squeaksource: 'Fuel'; 
	package: 'Fuel';
	package: 'FuelPackageLoader';
	load.

2) Load the configuration you want to capture in this way:
FLMetacelloStore default 
	capturePackagesDuring: [
		Gofer new squeaksource: 'MetacelloRepository'; package: 'ConfigurationOfSeaside30'; load.
		(Smalltalk at: #ConfigurationOfSeaside30) project latestVersion load: #(Core)] 
	prefixed: 'seaside'.

= Load =

1) Install Fuel:
Gofer it squeaksource: 'Fuel'; 
	package: 'Fuel';
	package: 'FuelPackageLoader';
	load.

2) Now run the loading script generated: fileIn './FuelMetacello/seaside-load-.st'."

3) "Start the server"
WAComancheAdaptor startOn: 8088.!

!FLMetacelloStore classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 4/21/2012 17:24'!
default

	^Default ifNil: [Default := self new]! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 02:45'!
allPackagesTogetherFileName

	^prefix, '-all-packages-together.fuel'! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 02:54'!
capturePackages: packageNames

	packageNames
		do: [:packageName |
			capturedPackageNames add: packageName.
			FLPackageStore new storeOn: allPackagesTogetherStream packageNamed: packageName ]
		displayingProgress: [:packageName | 'Capturing ', packageName ]
	! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 03:41'!
capturePackagesDuring: aBlock prefixed: aPrefix

	capturedPackageNames := OrderedCollection new.
	prefix := aPrefix.

	self outputFileNamed:  self allPackagesTogetherFileName do: [:aStream |
		capturing := true.
		allPackagesTogetherStream := aStream binary.
		aBlock value.
		capturing := false ].

	self writeLoadingScript.
! !

!FLMetacelloStore methodsFor: 'initialize-release' stamp: 'MartinDias 9/29/2011 02:26'!
initialize 

	super initialize.
	capturing := false.! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 03:42'!
loadingScriptFileName
	
	^prefix, '-load.st'! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 03:41'!
loadingScriptString

	^ '
	| packageFileNames |
	packageFileNames := ', capturedPackageNames asArray printString, '.
	
	(FileDirectory default directoryNamed: ''FuelMetacello'') 
			oldFileNamed: ', self allPackagesTogetherFileName printString, ' 
			do: [ :aStream | 
				aStream binary.
				packageFileNames 
					do: [ :packageFileName | FLPackageLoader new loadFrom: aStream ]
					displayingProgress: [ :packageFileName | ''Fuel importing '', packageFileName ]]'! !

!FLMetacelloStore methodsFor: 'streaming' stamp: 'MartinDias 9/29/2011 02:26'!
outputDirectory

	^(FileDirectory default directoryNamed: 'FuelMetacello') 
		assureExistence;
		yourself
! !

!FLMetacelloStore methodsFor: 'streaming' stamp: 'MartinDias 9/29/2011 02:26'!
outputFileNamed: aFileName do: aBlock

	^self outputDirectory forceNewFileNamed: aFileName do: aBlock! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 02:26'!
packageFileNameFor: packageName
 
	^prefix, '-', packageName, '.fuel'! !

!FLMetacelloStore methodsFor: 'listening' stamp: 'MartinDias 9/29/2011 02:26'!
packagesHasBeenLoaded: packageNames

	capturing ifTrue: [ self capturePackages: packageNames]! !

!FLMetacelloStore methodsFor: 'exporting' stamp: 'MartinDias 9/29/2011 03:43'!
writeLoadingScript

	self 
		outputFileNamed: self loadingScriptFileName 
		do: [ :scriptStream | scriptStream nextPutAll: self loadingScriptString ].! !
